<?php
/**
 * Xunhu For Typecho 付费阅读插件
 * @package Xunhu For Typecho
 * @author 迅虎网络
 * @version 1.0.0
 * @link http://www.wpweixin.net
 * @date 2019-07-09
 */
class XunhuPay_Plugin implements Typecho_Plugin_Interface {
    // 激活插件
    public static function activate() {
        Helper::addPanel(3, 'XunhuPay/libs/manage-posts.php', '文章付费', '管理文章付费', 'administrator');
        Helper::addAction('xunhu-post-edit', 'XunhuPay_Action');
        Typecho_Plugin::factory('Widget_Archive')->footer = array('XunhuPay_Plugin', 'footer');

        //后台增加字段
        Typecho_Plugin::factory('admin/write-post.php')->option = array(__CLASS__, 'setFeeContent');
        Typecho_Plugin::factory('Widget_Contents_Post_Edit')->finishPublish = array(__CLASS__, "updateFeeContent");
        Typecho_Plugin::factory('Widget_Archive')->select = array(__CLASS__, 'selectHandle');

        $db = Typecho_Db::get();
        $prefix = $db->getPrefix();
        self::alterColumn($db, $prefix . 'contents', 'xunhu_isFee', 'enum("y","n") DEFAULT "n"');
        self::alterColumn($db, $prefix . 'contents', 'xunhu_price', 'double(10,2) DEFAULT 0');
        self::alterColumn($db, $prefix . 'contents', 'xunhu_content', 'text');
        self::alterColumn($db, $prefix . 'users', 'xunhu_money', 'double(10,2) DEFAULT 0');
        self::alterColumn($db, $prefix . 'users', 'xunhu_point', 'int(11) DEFAULT 0');
        self::createTableXunhuFee($db);

        return _t('插件已经激活，需先配置插件信息！');
    }

    //把付费内容设置装入文章编辑页
    public static function setFeeContent($post) {
        $db = Typecho_Db::get();
        $row = $db->fetchRow($db->select('xunhu_content,xunhu_price,xunhu_isFee')->from('table.contents')->where('cid = ?', $post->cid));
        $xunhu_content = isset($row['xunhu_content']) ? $row['xunhu_content'] : '';
        $xunhu_price = isset($row['xunhu_price']) ? $row['xunhu_price'] : '';
        $xunhu_isFee = isset($row['xunhu_isFee']) ? $row['xunhu_isFee'] : '';
        if ($xunhu_isFee == "y") {
            $html = '<section class="typecho-post-option"><label for="xunhu_price" class="typecho-label">是否付费</label>
				<p><span><input name="xunhu_isFee" type="radio" value="n" id="xunhu_isFee-n">
				<label for="xunhu_isFee-n">
				免费的</label>
				</span><span>
				<input name="xunhu_isFee" type="radio" value="y" id="xunhu_isFee-y" checked="true">
				<label for="xunhu_isFee-y">
				要付费</label>
				</span></p></section>
				<section class="typecho-post-option"><label for="xunhu_price" class="typecho-label">付费价格（元）</label><p><input id="xunhu_price" name="xunhu_price" type="text" value="' . $xunhu_price . '" class="w-100 text"></p></section>
				<section class="typecho-post-option"><label for="xunhu_content" class="typecho-label">付费可见内容</label><p><textarea id="xunhu_content" name="xunhu_content" type="text" value="" class="w-100 text">' . $xunhu_content . '</textarea></p></section>';

        } else {
            $html = '<section class="typecho-post-option"><label for="xunhu_price" class="typecho-label">是否付费</label>
				<p><span><input name="xunhu_isFee" type="radio" value="n" id="xunhu_isFee-n" checked="true">
				<label for="xunhu_isFee-n">
				免费的</label>
				</span><span>
				<input name="xunhu_isFee" type="radio" value="y" id="xunhu_isFee-y">
				<label for="xunhu_isFee-y">
				要付费</label>
				</span></p></section>
				<section class="typecho-post-option"><label for="xunhu_price" class="typecho-label">付费价格（元）</label><p><input id="xunhu_price" name="xunhu_price" type="text" value="' . $xunhu_price . '" class="w-100 text"></p></section>
				<section class="typecho-post-option"><label for="xunhu_content" class="typecho-label">付费可见内容</label><p><textarea id="xunhu_content" name="xunhu_content" type="text" value="" class="w-100 text">' . $xunhu_content . '</textarea></p></section>';
        }
        _e($html);
    }

    //发布文章同时更新文章类型
    public static function updateFeeContent($contents, $post) {
        $xunhu_isFee = $post->request->get('xunhu_isFee', NULL);
        $xunhu_price = $post->request->get('xunhu_price', NULL);
        $xunhu_content = $post->request->get('xunhu_content', NULL);
        $db = Typecho_Db::get();
        $sql = $db->update('table.contents')->rows(array('xunhu_isFee' => $xunhu_isFee, 'xunhu_price' => $xunhu_price, 'xunhu_content' => $xunhu_content))->where('cid = ?', $post->cid);
        $db->query($sql);
    }

    //把增加的字段添加到查询中，以便在模版中直接调用
    public static function selectHandle($archive) {
        $user = Typecho_Widget::widget('Widget_User');
        if ('post' == $archive->parameter->type || 'page' == $archive->parameter->type) {
            if ($user->hasLogin()) {
                $select = $archive->select()->where('table.contents.status = ? OR table.contents.status = ? OR
						(table.contents.status = ? AND table.contents.authorId = ?)',
                    'publish', 'hidden', 'private', $user->uid);
            } else {
                $select = $archive->select()->where('table.contents.status = ? OR table.contents.status = ?',
                    'publish', 'hidden');
            }
        } else {
            if ($user->hasLogin()) {
                $select = $archive->select()->where('table.contents.status = ? OR
						(table.contents.status = ? AND table.contents.authorId = ?)', 'publish', 'private', $user->uid);
            } else {
                $select = $archive->select()->where('table.contents.status = ?', 'publish');
            }
        }
        $select->where('table.contents.created < ?', Typecho_Date::gmtTime());
        $select->cleanAttribute('fields');
        return $select;
    }

    //修改数据表字段
    public static function alterColumn($db, $table, $column, $define) {
        $prefix = $db->getPrefix();
        $query = "select * from information_schema.columns WHERE table_name = '" . $table . "' AND column_name = '" . $column . "'";
        $row = $db->fetchRow($query);
        if (count($row) == 0) {
            $db->query('ALTER TABLE `' . $table . '` ADD COLUMN `' . $column . '` ' . $define . ';');
        }
    }

    //创建支付订单数据表
    public static function createTableXunhuFee($db) {
        $prefix = $db->getPrefix();
        $db->query('CREATE TABLE IF NOT EXISTS `' . $prefix . 'xunhu_fees` (
		  `feeid` varchar(64) COLLATE utf8_general_ci NOT NULL,
		  `feecid` bigint(20) DEFAULT NULL,
		  `feeuid` bigint(20) DEFAULT NULL,
		  `feeprice` double(10,2) DEFAULT NULL,
		  `feetype` enum("alipay","wxpay","xunhu_wxpay","xunhu_alipay") COLLATE utf8_general_ci DEFAULT "xunhu_wxpay",
		  `feestatus` smallint(2) DEFAULT "0" COMMENT "订单状态：0、未付款；1、付款成功；2、付款失败",
		  `feeinstime` datetime DEFAULT NULL,
		  `feecookie` varchar(255) COLLATE utf8_general_ci DEFAULT NULL,
		  PRIMARY KEY (`feeid`)
		) DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;');
    }

    // 禁用插件
    public static function deactivate() {
        //删除页面模板
        Helper::removeAction('xunhu-post-edit');
        Helper::removePanel(3, 'XunhuPay/libs/manage-posts.php');
        return _t('插件已被禁用');
    }

    //在主题中直接调用
    public static function getXunhu() {
        //判断插件是否启用
        $all = Typecho_Plugin::export();
        if (!array_key_exists('XunhuPay', $all['activated'])){
            return;
        }

        include('libs/Parsedown.php');
        $Parsedown = new Parsedown();
        $db = Typecho_Db::get();
        $options = Typecho_Widget::widget('Widget_Options');
        $option = $options->plugin('XunhuPay');
        $cid = Typecho_Widget::widget('Widget_Archive')->cid;
        $query = $db->select()->from('table.contents')->where('cid = ?', $cid);
        $row = $db->fetchRow($query);
        if ($row['xunhu_isFee'] == 'y' && $row['authorId'] != Typecho_Cookie::get('__typecho_uid')) {
            if (!isset($_COOKIE["XunhuCookie"])) {
                $cookietime = $option->xunhu_cookietime == "" ? 1 : $option->xunhu_cookietime;
                $randomCode = md5(uniqid(microtime(true), true));
                setcookie("XunhuCookie", $randomCode, time() + 3600 * 24 * $cookietime);
                $XunhuCookie = $randomCode;
            } else {
                $XunhuCookie = $_COOKIE["XunhuCookie"];
            }
            $queryItem = $db->select()->from('table.xunhu_fees')->where('feecookie = ?', $XunhuCookie)->where('feestatus = ?', 1)->where('feecid = ?', $row['cid']);
            $rowItem = $db->fetchRow($queryItem);
            $rowUserItemNum = 0;
            if (Typecho_Cookie::get('__typecho_uid')) {
                $queryUserItem = $db->select()->from('table.xunhu_fees')->where('feeuid = ?', Typecho_Cookie::get('__typecho_uid'))->where('feestatus = ?', 1)->where('feecid = ?', $row['cid']);
                $rowUserItem = $db->fetchRow($queryUserItem);
                if (!empty($rowUserItem)) {
                    $rowUserItemNum = 1;
                }
            }
            if (count($rowItem) != 0 || $rowUserItemNum) { ?>
                <div style="background:#f8f8f8;padding:30px 20px;border:1px dashed #ccc;position: relative;z-index:999;margin:15px 0">
                    <span><?php echo $Parsedown->text($row['xunhu_content']) ?></span>
                    <span style="position: absolute;top:5px;left:15px;font-size:90%;color:#90949c;">付费可读</span>
                    <span style="position: absolute;top:8px;right:10px;"><img style="width:22px;" src="https://i.loli.net/2019/04/12/5cb00c4688f8f.png" alt=""></span>
                </div>
            <?php } else { ?>
                <div style="background:#f8f8f8;padding:30px 20px;border:1px dashed #ccc;position: relative;text-align:center;margin:15px 0;">
                    <form id="xunhuPayPost" onsubmit="return false" action="##" method="post" style="margin:10px 0;">
                        <?php if ($option->show_xunhu_payment == "all") { ?>
                            <input type="radio" id="feetype1" name="feetype" value="xunhu_wxpay" checked>微信支付
                            <input type="radio" id="feetype2" name="feetype" value="xunhu_alipay">支付宝支付
                        <?php } elseif ($option->show_xunhu_payment == "xunhu_wxpay") { ?>
                            <input type="radio" id="feetype1" name="feetype" value="xunhu_wxpay" checked>微信支付
                            <input type="hidden" id="feetype2" name="feetype" value="xunhu_alipay">
                        <?php } elseif ($option->show_xunhu_payment == "xunhu_alipay") { ?>
                             <input type="hidden" id="feetype1" name="feetype" value="xunhu_wxpay" >
                            <input type="radio" id="feetype2" name="feetype" value="xunhu_alipay" checked>支付宝支付
                        <?php } ?>
                        <div style="clear:left;"></div>
                        <div style="height:34px;line-height:34px;border:none;-moz-border-radius: 0px;-webkit-border-radius: 0px;border-radius:0px;">
                            价格： <?php echo $row['xunhu_price'] ?> 元
                        </div>
                        <button id="verifybtn" style="border-radius: 4px; border-style: none; width: 80px; height: 34px; line-height: 34px; padding: 0 5px; background-color: #F60; text-align: center; color: #FFF; font-size: 14px;cursor: pointer;" type="submit" onclick="xunhuPayPost()"/>付款</button>
                        <input type="hidden" name="action" value="paysubmit"/>
                        <input type="hidden" id="feecid" name="feecid" value="<?php echo $row['cid'] ?>"/>
                        <input type="hidden" id="feeuid" name="feeuid"
                               value="<?php Typecho_Cookie::get('__typecho_uid') ?>"/>
                        <input type="hidden" id="feecookie" name="feecookie" value="<?php echo $XunhuCookie ?>"/>
                    </form>
                    <div style="clear:left;"></div>
                    <span>温馨提示：<span style="color: red">免登录付款后1天内可重复阅读隐藏内容，<a href="/signin.html" style="">登录</a></span>用户付款后可永久阅读隐藏的内容。 </span>
                    <span style="position: absolute;top:5px;left:15px;font-size:90%;color:#90949c;">付费可读</span>
                    <span style="position: absolute;top:8px;right:10px;"><img style="width:22px;" src="https://i.loli.net/2019/04/12/5cb00c4688f8f.png" alt=""></span>
                </div>
                <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.4.0/jquery.min.js"></script>
                <script src="https://cdnjs.cloudflare.com/ajax/libs/layer/2.3/layer.js"></script>
                <script src="/usr/plugins/XunhuPay/assets/js/xunhu.js"></script>
            <?php } ?>
        <?php } elseif ($row['xunhu_isFee'] == 'y' && $row['authorId'] == Typecho_Cookie::get('__typecho_uid')) { ?>
            <div style="background:#f8f8f8;padding:30px 20px;border:1px dashed #ccc;position: relative;z-index:999;margin:15px 0">
                <span><?php echo $Parsedown->text($row['xunhu_content']) ?></span>
                <span style="position: absolute;top:5px;left:15px;font-size:90%;color:#90949c;">付费可读</span>
                <span style="position: absolute;top:8px;right:10px;"><img style="width:22px;" src="https://i.loli.net/2019/04/12/5cb00c4688f8f.png" alt=""></span>
            </div>
        <?php }
    }

    // 插件配置面板
    public static function config(Typecho_Widget_Helper_Form $form) {
        $db = Typecho_Db::get();
        $prefix = $db->getPrefix();
        $options = Typecho_Widget::widget('Widget_Options');
        $plug_url = $options->pluginUrl;

        //版本检查
        $div = new Typecho_Widget_Helper_Layout();

        $div->html('<small>		
			<h3>基础功能</h3>
			<span><p>第一步：配置下方各项参数；</p></span>
			<span>
				<p>
					第二步：在主题post.php文件相应位置添加：<font color="blue">&lt;?php echo XunhuPay_Plugin::getXunhu(); ?></font>。
				</p>
			</span>
			<span><p>第三步：等待其他用户或游客购买对应付费文章；</p></span>
		</small>');
        $div->render();

        //配置信息
        $xunhu_cookietime = new Typecho_Widget_Helper_Form_Element_Text('xunhu_cookietime', array('value'), 1, _t('免登录Cookie保存时间(天)'), _t('指定使用免登录付费后几天内可以查看隐藏内容，默认为1天，不会记录到买入订单中。'));
        $form->addInput($xunhu_cookietime);
        //xunhu_wxpay配置
        $xunhu_wxpay_mchid = new Typecho_Widget_Helper_Form_Element_Text('xunhu_wxpay_mchid', array('value'), "", _t('微信支付MchID'), _t('在<a href="https://admin.xunhuweb.com" target="_blank">虎皮椒官网</a>注册的MchID。'));
        $form->addInput($xunhu_wxpay_mchid);
         $xunhu_wxpay_private_key = new Typecho_Widget_Helper_Form_Element_Text('xunhu_wxpay_private_key', array('value'), "", _t('微信支付Private Key'), _t('在<a href="https://admin.xunhuweb.com" target="_blank">payjs官网</a>注册的Private Key。'));
        $form->addInput($xunhu_wxpay_private_key);
        $xunhu_wxpay_return_url = new Typecho_Widget_Helper_Form_Element_Text('xunhu_wxpay_return_url', array('value'), $plug_url . '/XunhuPay/libs/callback/xunhu_return.php', _t('支付后跳转地址'), _t('支付完成后跳转的页面地址。'));
        $form->addInput($xunhu_wxpay_return_url);
        $xunhu_wxpay_notify_url = new Typecho_Widget_Helper_Form_Element_Text('xunhu_wxpay_notify_url', array('value'), $plug_url . '/XunhuPay/libs/callback/xunhu_notify.php', _t('虎皮椒异步回调接口'), _t('支付完成后异步回调的接口地址。'));
        $form->addInput($xunhu_wxpay_notify_url);
        //xunhu_alipay配置
        $xunhu_alipay_mchid = new Typecho_Widget_Helper_Form_Element_Text('xunhu_alipay_mchid', array('value'), "", _t('支付宝支付MchID'), _t('在<a href="https://admin.xunhuweb.com" target="_blank">虎皮椒官网</a>注册的MchID。'));
        $form->addInput($xunhu_alipay_mchid);
        $xunhu_alipay_private_key = new Typecho_Widget_Helper_Form_Element_Text('xunhu_alipay_private_key', array('value'), "", _t('支付宝支付Private Key'), _t('在<a href="https://admin.xunhuweb.com" target="_blank">payjs官网</a>注册的Private Key。'));
        $form->addInput($xunhu_alipay_private_key);
        $xunhu_alipay_return_url = new Typecho_Widget_Helper_Form_Element_Text('xunhu_alipay_return_url', array('value'), $plug_url . '/XunhuPay/libs/callback/xunhu_return.php', _t('支付后跳转地址'), _t('支付完成后跳转的页面地址。'));
        $form->addInput($xunhu_alipay_return_url);
        $xunhu_alipay_notify_url = new Typecho_Widget_Helper_Form_Element_Text('xunhu_alipay_notify_url', array('value'), $plug_url . '/XunhuPay/libs/callback/xunhu_notify.php', _t('虎皮椒异步回调接口'), _t('支付完成后异步回调的接口地址。'));
        $form->addInput($xunhu_alipay_notify_url);
        //设置显示的支付网关，还是全部都显示
        $show_xunhu_payment = new Typecho_Widget_Helper_Form_Element_Radio('show_xunhu_payment', array('all' => _t('全部方式'),'xunhu_wxpay' => _t('微信支付'),'xunhu_alipay' => _t('支付宝支付')), 'all', _t('支付方式'), _t("选择需要开启的支付方式，默认全部方式。"));
        $form->addInput($show_xunhu_payment);
    }

    // 个人用户配置面板
    public static function personalConfig(Typecho_Widget_Helper_Form $form) {

    }

    // 获得插件配置信息
    public static function getConfig() {
        return Typecho_Widget::widget('Widget_Options')->plugin('XunhuPay');
    }

    public static function footer() {

    }

    public static function form($action = NULL) {
        /** 构建表格 */
        $options = Typecho_Widget::widget('Widget_Options');
        $form = new Typecho_Widget_Helper_Form(Typecho_Common::url('/action/xunhu-post-edit', $options->index),
            Typecho_Widget_Helper_Form::POST_METHOD);

        /** 标题 */
        $title = new Typecho_Widget_Helper_Form_Element_Text('title', NULL, NULL, _t('标题*'));
        $form->addInput($title);

        /** 是否付费 */
        $xunhu_isFee = new Typecho_Widget_Helper_Form_Element_Radio('xunhu_isFee',
            array('n' => _t('免费的'), 'y' => _t('要付费')),
            'n', _t('是否需付费*'));
        $form->addInput($xunhu_isFee);

        /** 付费价格 */
        $xunhu_price = new Typecho_Widget_Helper_Form_Element_Text('xunhu_price', NULL, NULL, _t('付费价格（元）*'));
        $form->addInput($xunhu_price);

        /** 付费可见内容 */
        $xunhu_content = new Typecho_Widget_Helper_Form_Element_Textarea('xunhu_content', NULL, NULL, _t('付费可见内容*'));
        $form->addInput($xunhu_content);

        /** 链接动作 */
        $do = new Typecho_Widget_Helper_Form_Element_Hidden('do');
        $form->addInput($do);

        /** 链接主键 */
        $cid = new Typecho_Widget_Helper_Form_Element_Hidden('cid');
        $form->addInput($cid);

        /** 提交按钮 */
        $submit = new Typecho_Widget_Helper_Form_Element_Submit();
        $submit->input->setAttribute('class', 'btn primary');
        $form->addItem($submit);
        $request = Typecho_Request::getInstance();

        if (isset($request->cid) && 'insert' != $action) {
            /** 更新模式 */
            $db = Typecho_Db::get();
            $prefix = $db->getPrefix();
            $post = $db->fetchRow($db->select()->from($prefix . 'contents')->where('cid = ?', $request->cid));
            if (!$post) {
                throw new Typecho_Widget_Exception(_t('文章不存在'), 404);
            }

            $title->value($post['title']);
            $xunhu_isFee->value($post['xunhu_isFee']);
            $xunhu_price->value($post['xunhu_price']);
            $xunhu_content->value($post['xunhu_content']);
            $do->value('update');
            $cid->value($post['cid']);
            $submit->value(_t('确认付费'));
            $_action = 'update';
        } else {
            $submit->value(_t('确认付费'));
        }

        if (empty($action)) {
            $action = $_action;
        }

        return $form;
    }
}