<?php
require_once '../../../../config.inc.php';

$db = Typecho_Db::get();
$prefix = $db->getPrefix();
date_default_timezone_set('Asia/Shanghai');

$action = isset($_POST['action']) ? addslashes($_POST['action']) : '';
if ($action == 'paysubmit') {
    $feetype = isset($_POST['feetype']) ? addslashes($_POST['feetype']) : '';
    $feecookie = isset($_POST['feecookie']) ? addslashes($_POST['feecookie']) : '';
    $feecid = isset($_POST['feecid']) ? intval(urldecode($_POST['feecid'])) : '';
    $feeuid = isset($_POST['feeuid']) ? intval($_POST['feeuid']) : 0;
    $location = isset($_POST['location']) ? urlencode($_POST['location']) : "";

    $options = Typecho_Widget::widget('Widget_Options');
    $option = $options->plugin('XunhuPay');
    $plug_url = $options->pluginUrl;

    $queryContent = $db->select()->from('table.contents')->where('cid = ?', $feecid);
    $rowContent = $db->fetchRow($queryContent);

    $config = [
        'mchid' => '',
        'private_key' => '',
        'api_url' => 'https://admin.xunhuweb.com',
    ];
    $payment='';
    switch ($feetype) {
        case "xunhu_wxpay":
            $config['mchid']=$option->xunhu_wxpay_mchid;
            $config['private_key']=$option->xunhu_wxpay_private_key;
            $payment='wechat';
            break;
        case "xunhu_alipay":
            $config['mchid']=$option->xunhu_alipay_mchid;
            $config['private_key']=$option->xunhu_alipay_private_key;
            $payment='alipay';
            break;
    }
    $orderID = time();
    $data = [
        'mchid' => $config['mchid'],
        'out_trade_no' => $orderID,  //订单编号
        'type' => $payment,
        'total_fee' => $rowContent['xunhu_price']*100,
        'body' => 'NO.' . $orderID,
        'notify_url' => $plug_url.'/XunhuPay/libs/callback/xunhu_notify.php',  //异步回调地址
        // 'return_url' => $plug_url.'/XunhuPay/libs/callback/xunhu_return.php?location='.$location,  //支付成功跳转地址，可携带参数
        'nonce_str' 	=> str_shuffle(time())
    ];
    require_once 'xunhu/Xunhu.php';
    require_once 'xunhu/phpqrcode.php';
    $Xunhu = new \xunhu\Xunhu($config);
    // if($Xunhu->is_app_client()){
    // 	if($payment=='wecaht'){
    // 		$redirect_url=$plug_url.'/XunhuPay/libs/callback/xunhu_return.php?location='.$location;  //支付成功跳转地址，可携带参数
    // 		$data['sign']=$Xunhu->generate_xh_hash($data,$config['private_key']);
    // 		$response = $Xunhu->http_post_json('https://admin.xunhuweb.com/pay/payment', json_encode($data));
		  //  $result     	  = $response?json_decode($response,true):null;
		  //  if(!$result){
		  //      throw new Exception('Internal server error',500);
		  //  }
		  //  $sign       	  = $Xunhu->generate_xh_hash($result,$config['private_key']);
		  //  if(!isset( $result['sign'])|| $sign!=$result['sign']){
		  //      throw new Exception($result['err_msg'],$result['err_code']);
		  //  }
		  //  $url =$result['mweb_url'];
	   //     header("Location:".$url.'&redirect_url='.urlencode($redirect_url));
	   //     exit;
    // 	}
	    
    // }
    $data['sign']=$Xunhu->generate_xh_hash($data,$config['private_key']);
    $response = $Xunhu->http_post_json('https://admin.xunhuweb.com/pay/payment', json_encode($data));
    $result     	  = $response?json_decode($response,true):null;
    if(!$result){
        throw new Exception('Internal server error',500);
    }
    $sign       	  = $Xunhu->generate_xh_hash($result,$config['private_key']);
    if(!isset( $result['sign'])|| $sign!=$result['sign']){
        throw new Exception($result['err_msg'],$result['err_code']);
    }
    $url =$result['code_url'];
    $errorCorrectionLevel = 'L';    //容错级别   
    $matrixPointSize = 5;           //生成图片大小  
    $filename = 'qrcode/'.microtime().'.png';
    //生成二维码图片  
    $QR = QRcode::png($url,$filename,$errorCorrectionLevel, $matrixPointSize, 2); 
    $QR = $filename;        //已经生成的原始二维码图片文件
	$QR = imagecreatefromstring(file_get_contents($QR));
	//输出图片
	imagepng($QR, 'qrcode.png');
	imagedestroy($QR);
	$qrcode_url=$plug_url.'/XunhuPay/libs/'.$filename;
    //输出图片
    if ($result["err_code"] == 0) {
        $data = array(
            'feeid' => $orderID,
            'feecid' => $feecid,
            'feeuid' => $feeuid,
            'feeprice' => $rowContent['xunhu_price'],
            'feetype' => $feetype,
            'feestatus' => 0,
            'feeinstime' => date('Y-m-d H:i:s', $time),
            'feecookie' => $feecookie
        );
        $insert = $db->insert('table.xunhu_fees')->rows($data);
        $insertId = $db->query($insert);
        $json = json_encode(array("status" => "ok", "type" => $feetype, "qrcode" =>$qrcode_url, "feeid" => $orderID),JSON_UNESCAPED_UNICODE|JSON_UNESCAPED_SLASHES);
        echo $json;
        exit;
    }

    $json = json_encode(array("status" => "fail"));
    echo $json;
    exit;
}
?>